'use strict';

app.controller('SubtitlesCtrl', ['$scope', 'FormService', 'formData', 
    function ($scope, FormService, formData) {
	
    $scope.formData = formData;
    $scope.hardSubsFontColor = buildFontColor(formData);

    $scope.submit = function (form) {
        FormService.submitForm('delivery', presaveFormData($scope.formData), form, $scope);
    };

    function buildFontColor(formData) {      
        if( formData.subtitles['hardSubsFontColor'] != null ) {
            return '#' + formData.subtitles['hardSubsFontColor'];
        } else {
            return '#ffffff';
        }
    }

    function presaveFormData(formData) {
    	var formCopy = JSON.parse(JSON.stringify(formData));

        if($scope.hardSubsFontColor.toLowerCase() != '#ffffff') {
            // white is default, don't send it, otherwise yes
            formCopy.subtitles['hardSubsFontColor'] = $scope.hardSubsFontColor.replace('#', '');
        }

    	return formCopy;
    }


}]);