'use strict';

app.controller('TrakttvCtrl', ['$scope', '$window', '$interval', 'FormService', 'formData', '$http', 'UrlService', 'RestService', 'AlertService', 'TranslateService', 'FormDataService',
    function ($scope, $window, $interval, FormService, formData, $http, UrlService, RestService, AlertService, TranslateService, FormDataService) {
	
    $scope.formData = formData;

    $scope.authenticated = formData['authenticated'];

    $scope.formSubmittable = function() {
        return $scope.authenticated == true;
    };

    var checkingTimer;

	$scope.submit = function (form) {
        FormService.submitForm('integration/trakttv', buildPayload($scope.formData), form, $scope);
        if(!$scope.formData['enabled']) {
            $scope.authenticated = false;
        }
    };

    $scope.authenticate = function() {
        $http.post(UrlService.absoluteUrl('/rest/integration/trakttv/authenticate')).
        then(function(response) {
            var userCode = response.data.userCode;
            var verificationUrl = response.data.verificationUrl;
            AlertService.info(userCode, TranslateService.getMessage("tab_trakttv_authorization_info"), 
                TranslateService.getMessage("tab_trakttv_authorization_button_validate"),
                TranslateService.getMessage("button_cancel"),
                function(isConfirm) {
                    if(isConfirm) {
                        $window.open(verificationUrl, '_blank');
                        checkingTimer = $interval(getLatestAuthenticationStatus, 5000);
                    }
                }
            );
        }, function(response) {
            RestService.processError(response);
        });
    };

    function getLatestAuthenticationStatus() {
        FormDataService.loadFormData('integration/trakttv', true).then(function(traktData) {
            if (traktData) {
                $scope.authenticated = traktData['authenticated'];
                if (traktData['waitingForAuthorization'] == false) {
                    $interval.cancel(checkingTimer);
                }
            }
        });
    }

    function buildPayload(formData) {
        var payload = {
          enabled: formData['enabled']
        };
        return payload;
    }

}]);