'use strict';

app.controller('TranscodingCtrl', ['$scope', 'FormService', 'TranslateService', 'BrowseFoldersService', 'cpuCores', 'formData', 
    function ($scope, FormService, TranslateService, BrowseFoldersService, cpuCores, formData) {
	
    $scope.cpuCores = buildCpuCores(cpuCores[0].value);
    $scope.formData = buildFormData(formData);

	$scope.submit = function (form) {
        FormService.submitForm('delivery', presaveFormData($scope.formData), form, $scope);
    };

    function buildCpuCores(maxCores) {
    	var cores = [];
    	cores.push({name: 0, value: TranslateService.getMessage('tab_transcoding_threads_optimal')});
    	for(var i = 0; i < maxCores; i++) {
    		var number = i+1;
    		cores.push( {name: number, value: number.toString()} );
    	}
    	return cores;
    }

    function buildFormData(formData) {
    	if(! ('threadsNumber' in formData.transcoding)) {
    		formData.transcoding['threadsNumber'] = 0;
    	}
    	return formData;
    }

    function presaveFormData(formData) {
    	var formCopy = JSON.parse(JSON.stringify(formData));
    	if(formCopy.transcoding.threadsNumber == 0) {
    		delete formCopy.transcoding['threadsNumber'];
    	}
    	return formCopy;
    }

     $scope.openFolderSelect = function() {
       
        var browseResult = BrowseFoldersService.openDialog('tab_transcoding_folder_location');

        browseResult.result.then(function (selectedFolder) {
            $scope.formData.transcoding.transcodingFolderLocation = selectedFolder; 
        });
    }

}]);