ALTER TABLE RENDERER DROP COLUMN ACCESS_GROUP_ID;

DROP TABLE REPOSITORY_ACCESS_GROUP;
DROP TABLE ONLINE_REPOSITORY_ACCESS_GROUP;
DROP TABLE ACCESS_GROUP;

CREATE TABLE USERS (ID INT NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) CONSTRAINT user_pk PRIMARY KEY,
                    NAME VARCHAR(128) NOT NULL UNIQUE,
                    PASSWORD VARCHAR(128) NOT NULL,
                    MAX_ALLOWED_MPAA_RATING VARCHAR(10));
ALTER TABLE RENDERER ADD COLUMN USER_ID INT CONSTRAINT rend_user_foreign_key REFERENCES USERS;

CREATE TABLE REPOSITORY_USER (ID INT NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) CONSTRAINT repo_user_pk PRIMARY KEY,
                              REPOSITORY_ID INT NOT NULL CONSTRAINT rap_repository_foreign_key REFERENCES REPOSITORY,
                              USER_ID INT NOT NULL CONSTRAINT ru_user_foreign_key REFERENCES USERS);

CREATE TABLE ONLINE_REPOSITORY_USER (ID INT NOT NULL GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) CONSTRAINT orepo_user_pk PRIMARY KEY,
                                     ONLINE_REPOSITORY_ID INT NOT NULL CONSTRAINT orap_repository_foreign_key REFERENCES ONLINE_REPOSITORY,
                                     USER_ID INT NOT NULL CONSTRAINT oru_user_foreign_key REFERENCES USERS);

CREATE TABLE PLAY_HISTORY (MEDIA_ITEM_ID INT NOT NULL CONSTRAINT ph_mi_foreign_key REFERENCES MEDIA_ITEM,
                           USER_ID INT NOT NULL CONSTRAINT ph_user_foreign_key REFERENCES USERS,
                           LAST_VIEWED_DATE TIMESTAMP,
                           BOOKMARK INT,
                           PRIMARY KEY (MEDIA_ITEM_ID, USER_ID));

ALTER TABLE MEDIA_ITEM ADD COLUMN STACK_DURATION INT;
ALTER TABLE MEDIA_ITEM ADD COLUMN STACK_FILE_SIZE BIGINT;
CREATE INDEX IDX_MEDIA_ITEM_DURATION ON MEDIA_ITEM (DURATION);
CREATE INDEX IDX_MEDIA_ITEM_STACK_DURATION ON MEDIA_ITEM (STACK_DURATION);

ALTER TABLE REPOSITORY ADD COLUMN ALIAS VARCHAR(256);
ALTER TABLE REPOSITORY ADD COLUMN IGNORED_FILE_EXTENSIONS VARCHAR(128);
ALTER TABLE REPOSITORY ADD COLUMN IGNORED_FOLDER_NAMES VARCHAR(128);
UPDATE REPOSITORY SET IGNORED_FOLDER_NAMES = '@eadir,.@__thumb';

UPDATE MEDIA_ITEM SET DIRTY = 1 WHERE FILE_TYPE IN ('VIDEO');
UPDATE REPOSITORY SET LAST_SCANNED = NULL;

INSERT INTO DB_SCHEMA_VERSION(VER_MAJ,VER_MIN,SCRIPT_FILE) VALUES (2,0,'script-2.0.sql');